#!/usr/bin/ksh
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2002,2006 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 

#----------------------------------------------------------------------------
# This is the script used to collect trace information necessary to debug
# ibnm problems.
#
# To decompress the output file, issue the gzip command with the '-d' option.
#
#     For example:    gzip -d c409hmc6.2003-07-15.09:54:36.snap.tar.gz
#
# To extract the tar file, issue the tar command with the '-tvf' options.
#
#     For example:    tar -tvf c409hmc6.2003-07-15.09:54:36.snap.tar
#
#----------------------------------------------------------------------------
export PATH=/bin:/usr/bin:$PATH

FILEPATH1="/tmp"
FILEPATH2="/opt/hsc/data"
FILEPATH3="/var/hsc/log"
FILEPATH4="/opt/hsc/data/ibnm"
FILEPATH5="/var/hsc/ibnm"
FILEPATH6="/"
FILEPATH7=$FILEPATH3

hostName=`hostname -s 2>/dev/null`
probDate=`date +%F 2>/dev/null`
probHour=`date +%H 2>/dev/null`
probMin=`date +%M 2>/dev/null`
probSec=`date +%S 2>/dev/null`

CFLAG=0;

 while test -n "$1"
        do
            case $1 in
                -c) CFLAG=1; break;;
                 *) exit 2;;
            esac
        done

tar_filename=$FILEPATH3/$hostName.$probDate'.'$probHour'.'$probMin'.'$probSec'.'snap.tar
if [ -f $tar_filename ]; then
  mv $tar_filename $tar_filename'.previous'
fi
tar_filename2=$FILEPATH3/$hostName.$probDate'.'$probHour'.'$probMin'.'$probSec'.'snap.tar.gz
if [ -f $tar_filename2 ]; then
  mv $tar_filename2 $tar_filename2'.previous'
fi


#----------------------------------------------------------------------------
#
# set up trace file
#
#----------------------------------------------------------------------------
/bin/rm -f /var/hsc/log/ibnm.snap.log
TRACE=$FILEPATH3/ibnm.snap.log
exec 3> $TRACE
#----------------------------------------------------------------------------
#
# Here are the filenames that need to be collected:
#
#----------------------------------------------------------------------------
FILELIST1='nmtraced.stdout nmtraced.stderr ibnmd.err ibnmfspd.err ibnmiod.err ibnmsmd.err ibnmtopod.err startFNMtrace.log ccfw.out ccfw.err'
FILELIST2='HmcNetConfig NmSessionConfig'
FILELIST3='IbnmEventLog.txt nmtrace.txt iqyylog.log hdwr_svr.log startIBNM.log tracelogd.debug.log tracelogd.debug.log.old'
FILELIST4='ElaCecEvents ElaIbSwEvents ElaSwFrusTrans ElaTopoEvents TopoDB'

# tar and gzip ibnm logs
#/bin/gzip -q -1 /var/hsc/log/*tar 2>/dev/null

# Check if more than 90% taken of /var if so then clean up 
look_for_var1=`/bin/df -k | /bin/grep var | /usr/bin/cut -d" " -f23 | /usr/bin/cut -d"/" -f2`
look_for_var2=`/bin/df -k | /bin/grep var | /usr/bin/cut -d" " -f24 | /usr/bin/cut -d"/" -f2`
look_for_var3=`/bin/df -k | /bin/grep var | /usr/bin/cut -d" " -f25 | /usr/bin/cut -d"/" -f2`
look_for_var4=`/bin/df -k | /bin/grep var | /usr/bin/cut -d" " -f26 | /usr/bin/cut -d"/" -f2`
look_for_var5=`/bin/df -k | /bin/grep var | /usr/bin/cut -d" " -f27 | /usr/bin/cut -d"/" -f2`

if [[ $look_for_var1 = "var" ]]
then
	look_for_var=22 
var_taken_up=`/bin/df -k | /bin/grep var | /usr/bin/cut -d" " -f22 | /usr/bin/cut -d"%" -f1`
fi
	
if [[ $look_for_var2 = "var" ]]
then
	look_for_var=23 
var_taken_up=`/bin/df -k | /bin/grep var | /usr/bin/cut -d" " -f23 | /usr/bin/cut -d"%" -f1`
fi

if [[ $look_for_var4 = "var" ]]
then
	look_for_var=25 
var_taken_up=`/bin/df -k | /bin/grep var | /usr/bin/cut -d" " -f25 | /usr/bin/cut -d"%" -f1`
fi

if [[ $look_for_var5 = "var" ]]
then
	look_for_var=26 
var_taken_up=`/bin/df -k | /bin/grep var | /usr/bin/cut -d" " -f26 | /usr/bin/cut -d"%" -f1`
fi

if [[ $look_for_var3 = "var" ]]
then
	look_for_var=24 
var_taken_up=`/bin/df -k | /bin/grep var | /usr/bin/cut -d" " -f24 | /usr/bin/cut -d"%" -f1`
fi

if [[ $var_taken_up -ge 85 ]]
then
	
	look_for_dump1=`/bin/df -k | /bin/grep dump | /usr/bin/cut -d" " -f23 | /usr/bin/cut -d"/" -f2`
	look_for_dump2=`/bin/df -k | /bin/grep dump | /usr/bin/cut -d" " -f24 | /usr/bin/cut -d"/" -f2`
	look_for_dump3=`/bin/df -k | /bin/grep dump | /usr/bin/cut -d" " -f25 | /usr/bin/cut -d"/" -f2`
	look_for_dump4=`/bin/df -k | /bin/grep dump | /usr/bin/cut -d" " -f26 | /usr/bin/cut -d"/" -f2`
	look_for_dump5=`/bin/df -k | /bin/grep dump | /usr/bin/cut -d" " -f27 | /usr/bin/cut -d"/" -f2`

	if [[ $look_for_dump1 = "dump" ]]
	then
		look_for_dump=22
	dump_taken_up=`/bin/df -k | /bin/grep dump | /usr/bin/cut -d" " -f22 | /usr/bin/cut -d"%" -f1`
	fi

	if [[  $look_for_dump2 = "dump" ]]
	then
		look_for_dump=23 
	dump_taken_up=`/bin/df -k | /bin/grep dump | /usr/bin/cut -d" " -f23 | /usr/bin/cut -d"%" -f1`
	fi

	if [[ $look_for_dump3 = "dump" ]]
	then
		look_for_dump=24 
	dump_taken_up=`/bin/df -k | /bin/grep dump | /usr/bin/cut -d" " -f24 | /usr/bin/cut -d"%" -f1`
	fi

	if [[ $look_for_dump4 = "dump" ]]
	then
		look_for_dump=25 
	dump_taken_up=`/bin/df -k | /bin/grep dump | /usr/bin/cut -d" " -f25 | /usr/bin/cut -d"%" -f1`
	fi

	if [[ $look_for_dump5 = "dump" ]]
	then
		look_for_dump=26
	dump_taken_up=`/bin/df -k | /bin/grep dump | /usr/bin/cut -d" " -f26 | /usr/bin/cut -d"%" -f1`
	fi

	/bin/gzip -f -q -1 /var/hsc/log/*.old* 2>/dev/null
	/bin/gzip -f -q -1 /var/hsc/log/*.tar 2>/dev/null
	/bin/gzip -f -q -1 /var/hsc/log/*.log.* 2>/dev/null
 		
	if [[ $dump_taken_up -le 50 ]]
	then
		/bin/mkdir -p /dump/federation+ib_snaps 2>/dev/null
		/bin/mv /var/hsc/log/*gz /dump/federation+ib_snaps 2>/dev/null
	fi
fi

#----------------------------------------------------------------------------
#
# Check for free space in /var
#
#----------------------------------------------------------------------------
MAX_IBNM_PERCENT=30
MIN_VAR_PERCENT=10
#----------------------------------------------------------------------------
#
# Function: ibnm_share_of_var
#
#----------------------------------------------------------------------------
function ibnm_share_of_var {
  DIR_SPACE=0
  LOG_SPACE=0
  #--------------------------------------------------------------------------
  # Include all of the IBNM trace files.
  #--------------------------------------------------------------------------
  for filename in $FILELIST1
  do
  if [ -f ${FILEPATH1}/$filename ]; then
      DIR_SPACE=$( du -k ${FILEPATH1}/$filename | tail -n 1 | awk '{print $1}' )
      (( LOG_SPACE = LOG_SPACE + DIR_SPACE ))
  fi
  done

  for filename in $FILELIST2
  do
  if [ -f ${FILEPATH2}/$filename ]; then
      DIR_SPACE=$( du -k ${FILEPATH2}/$filename | tail -n 1 | awk '{print $1}' )
      (( LOG_SPACE = LOG_SPACE + DIR_SPACE ))
  fi
  done

  for filename in $FILELIST3
  do
  if [ -f ${FILEPATH3}/$filename ]; then
      DIR_SPACE=$( du -k ${FILEPATH3}/$filename | tail -n 1 | awk '{print $1}' )
      (( LOG_SPACE = LOG_SPACE + DIR_SPACE ))
  fi
  done

  for filename in $FILELIST4
  do
  if [ -f ${FILEPATH4}/$filename ]; then
      DIR_SPACE=$( du -k ${FILEPATH4}/$filename | tail -n 1 | awk '{print $1}' )
      (( LOG_SPACE = LOG_SPACE + DIR_SPACE ))
  fi
  done

  for filename in $FILELIST5
  do
  if [ -f ${FILEPATH5}/$filename ]; then
      DIR_SPACE=$( du -k ${FILEPATH5}/$filename | tail -n 1 | awk '{print $1}' )
      (( LOG_SPACE = LOG_SPACE + DIR_SPACE ))
  fi
  done

  #--------------------------------------------------------------------------
  # Now include all of the snap files.
  #--------------------------------------------------------------------------
  for filename in $(ls ${FILEPATH3}/*snap.tar.gz 2>/dev/null);
  do
      DIR_SPACE=$( du -k $filename | tail -n 1 | awk '{print $1}' )
      (( LOG_SPACE = LOG_SPACE + DIR_SPACE ))
  done
  #--------------------------------------------------------------------------
  # Now include all of the snap files (Extended Error Data) from ELA.
  #--------------------------------------------------------------------------
  for filename in $(ls ${FILEPATH3}/BB*/*snap.tar.gz 2>/dev/null);
  do
      DIR_SPACE=$( du -k $filename | tail -n 1 | awk '{print $1}' )
      (( LOG_SPACE = LOG_SPACE + DIR_SPACE ))
  done
  #--------------------------------------------------------------------------
  # include the snap files (Extended Error Data) from ELA for power events.
  #--------------------------------------------------------------------------
  for filename in $(ls ${FILEPATH3}/101F*/*snap.tar.gz 2>/dev/null);
  do
      DIR_SPACE=$( du -k $filename | tail -n 1 | awk '{print $1}' )
      (( LOG_SPACE = LOG_SPACE + DIR_SPACE ))
  done

  (( IBNM_SHARE = ( 100 * LOG_SPACE ) / VAR_SPACE ))
  echo ibnm trace file space $LOG_SPACE                              >> $TRACE
  echo var space $VAR_SPACE                                           >> $TRACE
  echo ibnm share of /var ${IBNM_SHARE}%                               >> $TRACE
  echo $IBNM_SHARE
}

#----------------------------------------------------------------------------
#
# Function: var_free
#
#----------------------------------------------------------------------------
function var_free {
  # FREE_SPACE=`df -k /var | awk '/\/var/ {print $3}'` # for AIX
  # (( VAR_FREE = ( 100 * FREE_SPACE ) / VAR_SPACE )) # for AIX
  USED_SPACE=`df -k /var | awk '/\/var/ {print $3}'` # for Linux
  (( VAR_FREE = ( 100 * ( VAR_SPACE - USED_SPACE ) ) / VAR_SPACE )) # for Linux
  # echo free space        $FREE_SPACE                                >> $TRACE # for AIX
  echo used space        $USED_SPACE                                >> $TRACE # for Linux
  echo /var space        $VAR_SPACE                                 >> $TRACE
  echo free /var space   ${VAR_FREE}%                               >> $TRACE
  echo $VAR_FREE
}

VAR_SPACE=`df -k /var | awk '/\/var/ {print $2}'`

echo ================================================================ >> $TRACE
date                                                                  >> $TRACE
echo ibnm.snap running on `hostname`                                  >> $TRACE

#----------------------------------------------------------------------------
#
# If the space in /var occupied by ibnm logs exceeds the maximum allowed,
# then we need to remove 'old' snap files.
#
#----------------------------------------------------------------------------
while [ `ibnm_share_of_var` -ge $MAX_IBNM_PERCENT ]
do
  oldsnaps=`ls -t1 $FILEPATH3/*.snap.tar.gz 2>> $TRACE`
  if [ `echo "$oldsnaps" | wc -l` -gt 2 ]
  then
    OLDEST=`echo "$oldsnaps" | tail -1`
    echo removing $OLDEST to reduce our use of /var                   >> $TRACE
    rm $OLDEST
  else
    echo Our share of /var - `ibnm_share_of_var`% - is too large      >> $TRACE
    echo ibnm.snap failed                                             >> $TRACE
    echo 137
    exit 137
  fi
done

echo ibnm occupies less than ${MAX_IBNM_PERCENT}% of /var             >> $TRACE

#----------------------------------------------------------------------------
#
# If the /var directory still does not have enough space, then exit.
#
#----------------------------------------------------------------------------
if [ `var_free` -lt $MIN_VAR_PERCENT ]
then
  echo /var has less than `var_free`% free space                           >> $TRACE
  echo ibnm.snap failed                                                >> $TRACE
  echo 137
  exit 137
fi

echo More than ${MIN_VAR_PERCENT}% of /var is free. Continuing...     >> $TRACE

echo ================================================================ >> $TRACE

#----------------------------------------------------------------------------
#
# Form a list of files to tar together
#
#----------------------------------------------------------------------------
for filename in $FILELIST1
do
    if [ -f ${FILEPATH1}/$filename ]; then
        fileList1=$fileList1" "$filename
    fi
done

for filename in $FILELIST2
do
    if [ -f ${FILEPATH2}/$filename ]; then
        fileList2=$fileList2" "$filename
    fi
done

for filename in $FILELIST3
do
    if [ -f ${FILEPATH3}/$filename ]; then
        fileList3=$fileList3" "$filename
    fi
done

for filename in $FILELIST4
do
    if [ -f ${FILEPATH4}/$filename ]; then
        fileList4=$fileList4" "$filename
    fi
done

#-----------------------------------------------------------------------------
#
# These lists of filenames are being handled en mass per directory location
#
#-----------------------------------------------------------------------------

cd ${FILEPATH5}
for filename in $(ls NmTrace.* 2>/dev/null); 
do
	fileList5=$fileList5" "$filename
done

cd ${FILEPATH6}
for filename in $(ls core* 2>/dev/null);
do
        fileList6=$fileList6" "$filename
done

cd ${FILEPATH7}
for filename in $(ls core* 2>/dev/null);
do
        fileList7=$fileList7" "$filename
done

#----------------------------------------------------------------------------
#
# Next, tar the files
#
#----------------------------------------------------------------------------
echo Creating tarball from files:                     >> $TRACE
echo $FILEPATH1':' $fileList1                                          >> $TRACE
echo $FILEPATH2':' $fileList2                                          >> $TRACE
echo $FILEPATH3':' $fileList3                                          >> $TRACE
echo $FILEPATH4':' $fileList4                                          >> $TRACE
echo $FILEPATH5':' $fileList5                                          >> $TRACE
echo $FILEPATH6':' $fileList6                                          >> $TRACE
echo $FILEPATH7':' $fileList7                                          >> $TRACE

tar -cf $tar_filename -C $FILEPATH1 $fileList1 -C $FILEPATH2 $fileList2 -C $FILEPATH3 $fileList3 -C $FILEPATH4 $fileList4 -C $FILEPATH5 $fileList5 -C $FILEPATH6 $fileList6 -C $FILEPATH7 $fileList7

#----------------------------------------------------------------------------
#
# Now compress the tar file.
#
#----------------------------------------------------------------------------
echo Zipping the tar file:                                          >> $TRACE
echo $tar_filename                                                  >> $TRACE
gzip -q -1 $tar_filename

if [ $CFLAG -ne 1 ]
then
	echo 0
fi

# if we want to write to dvd
if [ $CFLAG -eq 1 ]
then
	# give the gzip process some time to finish
	/bin/sleep 10
                                                  
	# determine if we are mounted already                                                              
	need_mount=`/bin/cat /etc/mtab | /bin/grep cdrom`

	# if we are not mounted ...
	if [[ $need_mount == "" ]]
	then 
		# attempt to mount the cdrom drive
        	mount=`/bin/mount /media/cdrom` >> $TRACE 2>&1 
	
		need_mount=`/bin/cat /etc/mtab | /bin/grep cdrom`
		
		/bin/sleep 2
        	# if mount does not work, possibly need to format
		if [[ $need_mount == "" ]]
        	then
			# attempt to format disk
                	/usr/bin/mkudffs --media-type=dvdram /dev/hdc >> $TRACE 2>&1

			/bin/sleep 5

			# now try the mount again 
			mount_again=`/bin/mount /media/cdrom`  >> $TRACE 2>&1
		
			need_mount=`/bin/cat /etc/mtab | /bin/grep cdrom`

			/bin/sleep 2
			# if still cannot mount exit
			if [[ $need_mount == "" ]]
			then
				echo 2;
				echo "could not mount even after format try"; >> $TRACE 2>&1
				echo "Couldnt not mount cdrom drive" >> $TRACE 2>&1
				exit 2;			
			fi
        	fi
	fi
        
	# if we are all set copy snap to cdrom
	/bin/cp -p $tar_filename.gz /media/cdrom  >> $TRACE 2>&1

	# now cleanup ... unmount
	/bin/umount /media/cdrom  >> $TRACE 2>&1

	# exit rc = 0
	echo 0;
	exit 0;
fi
